
// usage: name the executable file exactly as the perl script you want to run,
// then add .exe to it (or any extension beginning with a single dot).
//
// Example: You want to run hello.pl, name the compiled executable hello.pl.exe



#include <EXTERN.h>               /* from the Perl distribution     */
#include <perl.h>                 /* from the Perl distribution     */

// link with perl58.lib/a/so

static PerlInterpreter *my_perl;
int main(int argc, char** argv)
{
   char * pos;
   char ** args = (char**)malloc(sizeof(char*)*(argc+1));
   int i;

	// Fin the last dot and remove all after it
   if(pos = strrchr(argv[0], '.'))
      * pos = 0;

	// Perpare the arguments for perl_parse
   args[0] = "";
   for (i = 0; i < argc; i++)
      args[i+1] = argv[i];

	// perl allocation and start
   my_perl = perl_alloc();
   perl_construct(my_perl);
   PL_exit_flags |= PERL_EXIT_DESTRUCT_END;
   perl_parse(my_perl, NULL, argc+1, args, (char **)NULL);
   perl_run(my_perl);

   // cleanup
   perl_destruct(my_perl);
   perl_free(my_perl);
}
